KD.company.Contact = function(companyMenu) {
	this.companyMenu = companyMenu;
}

KD.company.Contact.prototype = {
	constructor : KD.company.contact,
	companyName : null,
	companyAddress : null,
	allContactLoaded : false,
	oAuthPopup : null,
	options : {},
	initNotLogged : function(displayContact, options) {
		this.initCommon(displayContact, options);
		$(".companyProfileContact").live("click", function(event) {
			KD.login.popup.display();
			KD.login.popup.setMessage(loginMessage);
		});
	},
	init : function(unknownConnection, displayContact, options) {
		this.unknownConnection = unknownConnection;
		this.initCommon(displayContact, options);

		this.companyName = $("#_companyName").html();
		this.companyAddress = $("#_companyAddress").html();
		var that = this;

		$("._deleteContact").live("click", function(e) {
			that.deleteContact(e)
		});

		$("._company_contact_kadmail_it").live("click", function(event) {
			openWindowForNewKadmail($(this).children("a").attr("href"));
			event.preventDefault();
		});
	},
	/**
	 * Common initialization, for logged & not logged
	 */
	initCommon : function(displayContact, options) {
		this.options = options;
		var that = this;
		$("#_moreContact, #_companyContact").click(function(e) {
			that.displayContact();
		});
		this.contactsContainer = $("#_companyContactContainer");
		if (displayContact) {
			this.displayContact();
		}
	},
	// ============== deleteContact
	deleteContact : function(event) {
		jConfirm(this.options.deleteConfirmTitle,
				this.options.deleteConfirmTitle, function(r) {
					if (r) {
						var $form = $(event.target).prev();
						$form.ajaxSubmit();
						var id = $form.children("[name='id']").val();
						$("#" + id).remove();
					}
				});
	},
	/**
	 * Display the contacts.
	 */
	displayContact : function() {
		if (this.unknownConnection) {
			if (this.oAuthPopup == null) {
				this.oAuthPopup = new KD.OAuth(this);
			}
			this.oAuthPopup.popup.display();
		} else {
			this.getAllContactsForCompany();
			this.companyMenu.display("_companyContact");
		}
	},
	/**
	 * Ajax request to get all the existing contacts of the current company.
	 */
	getAllContactsForCompany : function() {
		if (!this.allContactLoaded) {
			this.allContactLoaded = true;
			var that = this;
			$.ajax({
				url : that.options.genericSearchUrl,
				dataType : "html",
				success : function(data) {
					that.contactsContainer.html(data);
					$("input._contact_attr_company").each(
							function(index, elem) {
								if ($(this).val() == undefined
										|| $(this).val() == "") {
									$(this).val(that.companyName);
									$(this).next().val(that.companyAddress);
								}
							});
					that.initVcard();
					that.initContactEvent();
				}
			});
		}
	},
	/**
	 * Init the vCard div. Should be called once, when the vCard area is loaded
	 * in the dom (so after we get all the existing contacts of the current
	 * company)
	 */
	initVcard : function() {
		// ============== VCard Management
		var vcard = new VCard("#_contactVCardArea", this.options.noDataMsg,
				this.options.isMixdataMemberMessage);
		vcard.init($("._fullName"), function() {
			vcard.display($(this).parent(), false);
		});
	},
	initContactEvent : function() {
		$("._contact_show_email").live(
				"click",
				function() {
					showDetails($(this).parent().children(
							".mixdatav2_companyProfileContactMailDisplay"));
				});
		$("._contact_show_tel").live(
				"click",
				function() {
					showDetails($(this).parent().children(
							".mixdatav2_companyProfileContactTelDisplay"));
				});
		$(".mixdatav2_companyProfileContactMailTelDeleteBtnPosition").live(
				"click", hideDetails);

		function showDetails($details) {
			if ($details.is(":hidden")) {
				$details.fadeIn();
			}
		}

		function hideDetails() {
			var $details = $(this).parent();
			if ($details.is(":visible")) {
				$details.fadeOut();
			}
		}
	}

}