KD.company.Maps = function (addressNotFound) {
	this.addressNotFound = addressNotFound ;
} ;
KD.company.Maps.prototype = {
		constructor: KD.company.Maps,
		init: function (address) {
			var summaryHeadOfficeMap = new KD.gMaps.Map();
			summaryHeadOfficeMap.init($("#_summaryHeadOfficeMap"), {addressNotFound: this.addressNotFound});
			summaryHeadOfficeMap.goToAddress(address);
		},
		initOffices: function () {
			var that = this;
			$.each($('._mapOffice'), function (i) {
				var address = $(this).attr('alt');
				var map = new KD.gMaps.Map();
				map.init($(this), {addressNotFound: that.addressNotFound});
				map.goToAddress(address);
			});
		}
}

KD.company.Help = function (messages) {
	var helpButton = $('#_helpButton') ;
	if(helpButton.length>0) {
		var popupHandler = new KD.help.PopupHandler();
		popupHandler.addPosition({text: messages[0].txt, title: messages[0].title, offset: "6 15 0 0", of: "#_popupSaveTargetAction", direction: "left", css: {width: 300}});
		popupHandler.addPosition({text: messages[1].txt, title: messages[1].title, css: {width: 250}, offset: "30 0 0 0", of: "#_companyContact", direction: "bottom"});
		helpButton.click(function () {
			popupHandler.start();
		});
	}
};

KD.company.Menu = function (companyMaps) {
	this.companyMaps = companyMaps ;
};
KD.company.Menu.prototype = {
		constructor: KD.company.Menu,
		urls:{companyOffices: ""},
		init: function (urls) {
			var that = this ;
			this.urls = urls ;
			$("#_companyMenu").children("li").click(function () {
				var id = $(this).attr("id");
				that.show(id);
			});
			$("#_moreActivity").click(function () {
				that.show("_companyActivity");
			});
			$("#_moreOffices").click(function () {
				that.show("_companyOffices");
			});
		},
		/**
		 * Show the menu. Load the content if needed.
		 */
		show: function (id) {
			var that = this ;
			//Content not yet loaded. Me make the ajax call
			if(this.getContainer(id).hasClass("_notLoaded")) {
				this.getContainer(id).removeClass("_notLoaded")
				var url = this.urls[id.substring(1, id.length)] ;
				$.ajax({
					url: url,
					dataType : "html",
					context: document.body,
					success: function(data){
						that.getContainer(id).html(data);
						that.display(id);
						//Must be fired when the element is loaded in the dom, otherwise google maps gets crazy. 
						//companyMaps is defined in company.ftl. 
						//Doesn't work to define the object in company-office.ftl.
						if(id == "_companyOffices") {
							that.companyMaps.initOffices();
						}
					}
				});
			} else if(id != "_companyContact") {
				this.display(id);
			}
		},
		/**
		 * Display a menu, given a menu id (eg "_companySummary" or "_companyOffices")
		 */
		display: function(id) {
			$("#_companyMenu").children("li").removeClass("current");
			$("#"+id).addClass("current");
			//hide all the menu
			$("#_companyContainer").children("div:visible").each(function () {
				$(this).css("display", "none");
			});
			//Display the good one
			this.getContainer(id).css("display", "block");
		},
		/**
		 * return the associated container div object from a menu id.
		 */
		getContainer: function(id) {
			return $("#"+id+"Container") ;
		}
		
}