KD.company.ContactDirectly = function () {};
KD.company.ContactDirectly.prototype = {
		constructor: KD.company.ContactDirectly,
		/**
		 * TODO: properties shouldn't be stored in the popup.
		 */
		init: function (notification, defaultMessage, errorMessage,loginMessage) {
			var contactDirectlyPopup = new Popup("_popupContactDirectly", {
				needLoggedUser: true, 
				loginMessage: loginMessage,
				displaySelectors: "._popupContactDirectlyAction", 
				initBeforeDisplay: function () {
					contactDirectlyPopup.othersInput.val("");
					contactDirectlyPopup.messageInput.val(contactDirectlyPopup.defaultMessage);
					if (contactDirectlyPopup.receptorsInput) {
						contactDirectlyPopup.receptorsInput.filter(":checked").attr("checked", false);
					}
					contactDirectlyPopup.resetError();
				}
			});
			contactDirectlyPopup.notification = notification;
			contactDirectlyPopup.defaultMessage = defaultMessage;
			contactDirectlyPopup.errorMessage = errorMessage;
			contactDirectlyPopup.form = $("form[name='contactDirectlyForm']");
			contactDirectlyPopup.receptorsInput = $("form[name='contactDirectlyForm'] input[name='receptors']");
			contactDirectlyPopup.receptorsParent = contactDirectlyPopup.receptorsInput.parent().parent().parent();
			contactDirectlyPopup.othersInput = $("form[name='contactDirectlyForm'] input[name='others']");
			contactDirectlyPopup.othersParent = contactDirectlyPopup.othersInput.parent();
			contactDirectlyPopup.messageInput = $("form[name='contactDirectlyForm'] textarea[name='message']");
			contactDirectlyPopup.messageParent = contactDirectlyPopup.messageInput.parent();
			contactDirectlyPopup.othersInput.change(validateEmails);
			contactDirectlyPopup.messageInput.change(validateMessage);

			var options = {
				beforeSubmit : showRequest,
				success : manageResponse,
				dataType : 'json'
			};

			contactDirectlyPopup.form.ajaxForm(options);

			// pre-submit callback
			function showRequest(formData, jqForm, options) {
				if (!validateEmails() || !validateReceptors() || !validateMessage()) {
					contactDirectlyPopup.showError(contactDirectlyPopup.errorMessage);
					return false;
				}
				return true;
			}

			function manageResponse(data) {
				if (data.errors != undefined) {
					$.each(data.errors, function(index, elem) {
						if (elem.field != undefined) {
							var $input = $("form[name='contactDirectlyForm'] *[name=" + elem.field + "]");
							$input.next().html(elem.defaultMessage);
							addError($input, $input.parent());
						}
					});
					contactDirectlyPopup.showError(contactDirectlyPopup.errorMessage);
				} else {
					contactDirectlyPopup.hide();
					contactDirectlyPopup.resetError();
					KD.notification.display(contactDirectlyPopup.notification);
				}
			}

			function validateEmails() {
				return validate(isValidEmailsString, contactDirectlyPopup.othersInput, contactDirectlyPopup.othersParent);
			}

			function validateReceptors() {
				if (contactDirectlyPopup.receptorsInput.filter(":checked").size() == 0 && hasNoText(contactDirectlyPopup.othersInput.val())) {
					return addError(contactDirectlyPopup.receptorsInput, contactDirectlyPopup.receptorsParent);
				}
				return removeError(contactDirectlyPopup.receptorsParent);
			}

			function validateMessage() {
				return validate(isNotEmpty, contactDirectlyPopup.messageInput, contactDirectlyPopup.messageParent);
			}
		}
}
