var KD = {
	utils: {
		
		
		/**
		 * Copy the customOptions properties to the defaultOptions object.
		 */
		initOptions: function (customOptions, defaultOptions) {
			if(typeof(customOptions) !== "undefined") {
				for(var i in customOptions) {
					defaultOptions[i] = customOptions[i];
				}
			}
		},
		/**
		 * Remove an element to an input list.
		 */
		removeFromInput: function(input, value) {
			input.val(this.removeValueFromList(input.val(), value));
		},
		/**
		 * Add an element to an input list.
		 */
		addToInput: function(input, value) {
			input.val(this.addValueToList(input.val(), value));
		},
		/**
		 * Remove a value from a given string list
		 */
		removeValueFromList: function(stringList, value, delimitor) {
			delimitor = delimitor || ",";
			var list = this.split(stringList, delimitor) ;
			list.splice($.inArray(value, list), 1 );
			return list.join(delimitor);
		},
		/**
		 * Add a value to a given string list. Remove duplicated, the value is unique in the list.
		 */
		addValueToList: function(stringList, value, delimitor) {
			delimitor = delimitor || ",";
			var list = this.split(stringList, delimitor) ;
			if($.inArray(value, list) == -1) {
				list.push(value);
			}
			return list.join(delimitor);
		},
		/**
		 * Split a string and return an array. If the string is === "", return []
		 * (not [""])
		 */
		split: function(aString, regex) {
			if(aString === "") {
				return [];
			}
			return aString.split(regex);
		},
		/**
		 * Add a parameter to the given url.
		 */
		addParameterToURI: function(aUrl, aName, aValue) {
			if(aUrl.indexOf("?")==-1) {
				aUrl+="?";
			} else {
				aUrl+="&";
			}
			aUrl+=aName+"="+aValue;
			return aUrl;
		},
		/**
		 * Dynamic script loading for a given url, for asynchronous loading.
		 */
		dsl: function(src) {
			var script = document.createElement("script");
			script.type = "text/javascript";
			script.src = src;
			document.body.appendChild(script);
		},
		/**
		 * When a form is display: if not in the dom when the page is loaded(injected with js), IE doesn't catch the enter event and doesn't submit the form.
		 * Calling this method with the form selector fix this issue.
		 */
		submitOnEnter: function(formSelector) {
		    $(formSelector+' input').keydown(function(e){
		        if (e.keyCode == 13) {
		            $(this).parents('form').submit();
		            return false;
		        }
		    });
		},
		/**
		 * Init text input with title attribute : set the title as a grey
		 * default text when nothing is set in the input.
		 * May be called with a parent selector to limit the initTitle to this part of the dom.
		 */
		initTitle : function (parentSelector) {
			var $inputWithTitles = this.getInputWithTitles();
			$inputWithTitles.live('focusin', function () {
				var $input = $(this);
				if($input.prop('title') == $input.val()) {
					$input.val('').removeClass('mixdatav2_inputGenericExample');
					$input.val('');
				}
			});
			$inputWithTitles.live('focusout', function () {
				var $input = $(this);
				if ($.trim($input.val()) == '') {
					$input.addClass('mixdatav2_inputGenericExample');
					$input.val($input.prop('title'));
				}
			});
			$inputWithTitles.focusout();
		},
		/**
		 * Return a list of input with a title attribute, in a parentSelector (can be ommitted)
		 */
		getInputWithTitles: function (parentSelector) {
			parentSelector = parentSelector || "" ;
			return $(parentSelector+'textarea[title!=""], '+parentSelector+' input[type="text"][title!=""]');
		},
		/**
		 * Reset the title of the inputs. Usefull when the value of the input is dynamically changed.
		 * Only works for inputs initialized with the initTitle() method.
		 */
		resetTitle: function (parentSelector) {
			this.getInputWithTitles().focusout();
		},
		focusInput :function () {
			//TODO: deprecated.
			$(".mixdatav2_genericInputAreaAlert .mixdatav2_genericInput").live('focusin change', function() {
				$(this).parent().find(".mixdatav2_genericInputAlertMsg").show();
			});
			var mixdatav2_genericInputs = $(".mixdatav2_genericInput") ;
			mixdatav2_genericInputs.live('focusout', function() {
				$(this).parent().find(".mixdatav2_genericInputAlertMsg").hide();
			});
	
			mixdatav2_genericInputs.live("focusin", function() {
				$(this).parent().addClass("mixdatav2_genericInputAreaFocus");
			});
			mixdatav2_genericInputs.live("focusout", function() {
				$(this).parent().removeClass("mixdatav2_genericInputAreaFocus");
			});
			
			//New version
			var inputBlocs = $(".inputBloc");
			inputBlocs.live('focusin change', function() {
				$(this).find(".inputErrorBloc").css('visibility', 'visible');
			});
			inputBlocs.live('focusout', function() {
				$(this).find(".inputErrorBloc").css('visibility', 'hidden');
			});
			
			
			
			/**
			 * TODO: pas sur que ce soit vraiment common ca ?
			 */
			$(".mixdatav2_genericInputAreaAlert .mixdatav2_kadmailNewMailTextArea").live('focusin', function() {
				$(this).parent().find(".mixdatav2_genericInputAlertMsg").show();
			});
			
			
			$(".mixdatav2_kadmailNewMailTextArea").live('keydown', function() {
				$(this).parent().find(".mixdatav2_genericInputAlertMsg").hide();
			});
	
			
			$(".mixdatav2_kadmailNewMailTextArea").live("focusin", function() {
				$(this).parent().addClass("mixdatav2_genericInputAreaFocus");
			});
					
			
			$(".mixdatav2_kadmailNewMailTextArea").live("focusout", function() {
				$(this).parent().removeClass("mixdatav2_genericInputAreaFocus");
			});
		},
		/**
		 * String utilities
		 */
		string: {
			/**
			 * Capitalize the first letter of the string.
			 */
			capitalize: function (aString) {
				return aString.substring(0,1).toUpperCase() + aString.substring(1);
			},
			/**
			 * Return the value in parenthesis in a given string.
			 */
			getValueInParenthesis: function(aString) {
				return aString.substring(aString.indexOf("(")+1,aString.indexOf(")"));
			},
			/**
			 * Replace the value in parenthesis in a given string by another one.
			 */
			replaceValueInParenthesis: function(aString, newValue) {
				var leftPart = aString.substring(0,aString.indexOf("(")+1);
				var rightPart = aString.substring(aString.indexOf(")"), aString.lenght);
				return leftPart+newValue+rightPart;
			}
		},
		/**
		 * Color utilities
		 */
		color: {
			/**
			 * Transform a rgb to a hex[6]
			 */
			rgb2hex: function(rgb) {
			    function hex(x) {
			        return ("0" + parseInt(x).toString(16)).slice(-2);
			    }
			    return "#" + hex(rgb[0]) + hex(rgb[1]) + hex(rgb[2]);
			},
			/**
			 * Transform a hex[6] to a rgb
			 */
			hex2rgb: function (colour) {
				var r,g,b;
				if (colour.charAt(0) == "#" ) {
					colour = colour.substr(1);
				}
				function hex(i) {
					return parseInt(colour.charAt(i) + colour.charAt(i+1),16);
				} 
				return [hex(0),hex(2),hex(4)] ;
			},
			/**
			 * Return an interpolation of a color between a min and a max (hex values), given a percentage.
			 */
			getColor: function(percent, colorMax, colorMin) {
				var rgbMax = this.hex2rgb(colorMax);
				var rgbMin = this.hex2rgb(colorMin);
				var rgb = [];
				for(var i=0;i<rgbMax.length;i++) {
					rgb[i] = (rgbMax[i] - rgbMin[i])*percent/100 + rgbMin[i];
				}
				return this.rgb2hex(rgb);
			}
		}
	},
	object: {
		/**
		 * prototype used to set options value in a custom generic Object. (eg.
		 * Popup)
		 */
		OptionConstructor: function () {
			this.options = {};
			this.setOptions = function (options) {
				KD.utils.initOptions(options, this.options);
			}
		}
	},
	company:{},
	target:{},
	user:{},
	admin:{},
	visu:{}
} ;

// Public validation functions

function isValidEmail(email) {
	var emailAddressRegex = new RegExp("^[A-Za-z0-9._%+-]+@[A-Za-z0-9.-]+\\.[a-zA-Z]{2,4}$");
	return emailAddressRegex.test(email);
}

function isValidLength(value, min) {
	// need to store in a variable for IE, don't ask why ...
	var val = jQuery.trim(value);
	return val.length >= min;
}

function isLengthBetween(value, min, max) {
	// need to store in a variable for IE, don't ask why ...
	var val = jQuery.trim(value);
	return val.length >= min && val.length <= max;
}

function isEquals(value1, value2) {
	return value1 == value2;
}

function isNotEmpty(value) {
	return !hasNoText(value);
}

function hasNoText(string) {
	// need to store in a variable for IE, don't ask why ...
	var val = jQuery.trim(string);
	return val.length == 0;
}

function isValidEmailsString(emails) {
	var valid = true;
	if (!hasNoText(emails)) {
		var splitText = emails.split(",");
		$(splitText).each(function(index) {
			if (!isValidEmail(jQuery.trim(this))) {
				valid= false;
			}
		});
	}
	return valid;
}
function validate(validationFunction, $input, $parent) {
	if(typeof($parent) == "undefined") {
		$parent = $input.parent();
	}
	var value = $input.val();
	if (value == $input.prop('title')) {
		value = "";
	}
	if (validationFunction(value)) {
		return removeError($parent);
	} else {
		return addError($input, $parent);
	}
}

/*
 * Adds error style on the given input (ie : puts the focus in the input, shows
 * the error label and adds the error class to the parent).
 */
// TODO Remove empty arg input
function addError($input, $parent) {
	$parent.addClass("mixdatav2_genericInputAreaAlert");
	$parent.removeClass("mixdatav2_availableMark");
	return false;
}

/*
 * Removes the error status (ie : hides the error label and removes the error
 * class on the parent div).
 */
function removeError($parent) {
	$parent.removeClass("mixdatav2_genericInputAreaAlert");
	$parent.removeClass("mixdatav2_requiredData");
	$parent.addClass("mixdatav2_availableMark");
	return true;
}

function createStringOfList(selectors, target, attribute, reset) {
	var buffer ="";
	if (!reset) {
		buffer = target.attr(attribute) ;
	}
	selectors.each(function(){
		if(buffer != "") {
			buffer +=",";
		}
		buffer +=""+$(this).val()
	});
	target.attr(attribute, buffer);
}

/**
 * Hides or Shows elements by selecting a value on a select element.
 */
function selectFilter(select, elem, all) {
	$(select).live("change", function() {
		var value = $(this).val();
		if (value === all) {
			$(elem).show();
		} else {
			$(elem).hide();
			$("."+ value).show();
		}
	});
}

/**
 * Returns field value but returns an empty string instead of a null or
 * undefined value.
 */
function getStringValue(field) {
	if (field === null || field === undefined) {
		return "";
	} else {
		return field;
	}
}


/**
 * @warn Buttons are the outer div representing the input if the input is
 *       'decorated'.
 */

/**
 * Makes the button looks activated.
 */
function activateButtons($buttons) {
	$buttons.each(function(index, button) {
		var $button = $(button);
		$button.removeClass("_desactivated");
		if ($button.hasClass("mixdatav2_optionsBarToolBarItemDesactivated")) {
			$button.removeClass("mixdatav2_optionsBarToolBarItemDesactivated");
		}
		if ($button.hasClass("mixdatav2_generalInput")) {
			$button.removeClass("mixdatav2_desactivatedInput");
			$button.children("input").removeAttr("disabled");
		}
	});
}

/**
 * Makes the button looks desactivated.
 */
function disactivateButtons($buttons) {
	$buttons.each(function(index, button) {
		var $button = $(button);
		$button.addClass("_desactivated");
		if ($button.hasClass("mixdatav2_optionsBarToolBarItem") && !$button.hasClass("mixdatav2_optionsBarToolBarItemDesactivated")) {
			$button.addClass("mixdatav2_optionsBarToolBarItemDesactivated");
		}
		if ($button.hasClass("mixdatav2_generalInput")) {
			$button.addClass("mixdatav2_desactivatedInput");
			$button.children("input").attr("disabled","disabled");
		}
		if ($button.hasClass("greyButton") || $button.hasClass("greyButtonBiger") || $button.hasClass("greenButton") || $button.hasClass("greenButtonBiger")) {
			$button.addClass("mixdatav2_optionsBarToolBarItemDesactivated");
		}
	});
}

/**
 * Returns true if the button looks activated.
 */
function isButtonActivated($button) {
	return !$button.hasClass("mixdatav2_optionsBarToolBarItemDesactivated")
			&& !$button.hasClass("mixdatav2_desactivatedInput");
}

function initAreasAndFunction(urlAskFunction, functionSelectMsg) {
	var $areaSelect = $("select[name='areas']");

	$areaSelect.live("change",function() {
		var $functions = $(this).parent().find("select[name!='areas']");
		$.ajax( {
			url : urlAskFunction,
			dataType : "json",
			data : {
				area : $(this).val()
			},
			success : function(data) {
				if (data.functions.lenght == 0) {
					$functions.html("");
					$functions.attr("disabled", "disabled");
				} else {
					$functions.html("");
					$functions.append('<option selected="selected" value="">' + functionSelectMsg + '</option>');
					$.each(data.functions, function(index, value) {
						$functions.append('<option value="' + value.id + '">' + value.title + '</option>');
					});
					$functions.removeAttr("disabled");
				}
			}
		});
	});

	$areaSelect.each(function(){
		$(this).children("option:first").attr("selected", "selected");
		
		var $parent = $(this).parent();
		var $userFunction = $parent.find("input[type='hidden'][name='functionId']");
		if ($userFunction.val() != null) {
			var $functionSelect = $parent.find("select[name!='areas']");
			$functionSelect.append('<option value="">' + functionSelectMsg + '</option>');
			$functionSelect.append("<option value='" + $userFunction.val() + "' selected='selected'>"+$userFunction.attr("title")+"</option>");
			$functionSelect.removeAttr("disabled");
		}
	});
}

function openWindowForNewKadmail(url) {
	window.open(url, 'window', 'width=600,height=600,scrollbars=yes,status=yes');
}

function openWindowForContactsCommercialForm() {
	window.open('https://spreadsheets.google.com/viewform?hl=en&pli=1&formkey=dG1hV08wRHMzRmZ5NmFyQXk3NEQ3WWc6MQ#gid=0', 'feedback',
	'height=770,width=640,toolbar=no,menubar=yes,location=no,resizable=yes,scrollbars=yes,status=no');
	return false;
}

function openWindowForTargetCommercialForm() {
	window.open('https://spreadsheets.google.com/viewform?hl=en&formkey=dEJLNG9WNG1EYWRNaU9lanJ2OE1JWkE6MQ#gid=0', 'feedback',
	'height=770,width=640,toolbar=no,menubar=yes,location=no,resizable=yes,scrollbars=yes,status=no');
	return false;
}

/*
 * Jquery script used to set of field as a set of comma-separated email
 * addresses. E.g. "user1@mixdata.com,user2@mixdata.com". The controller should
 * use a SetPropertyEditor (and so empty elements are removed). So
 * ",,user1@mixdata.com,user2@mixdata.com,," is valid too.
 * 
 * receptorCheckboxesSelector : jQuery selector for the receptor checkBoxes
 * (each checkBox is a potential receptor i.e. its value is the email address)
 * otherReceptorsCheckboxSelector : jQuery selector for the checkBox telling if
 * additional receptors have to be inserted otherReceptorsFieldSelector : jQuery
 * selector for the field of additional receptors
 */

function formToEmailAddresses(receptorCheckboxesSelector, otherReceptorsCheckboxSelector, otherReceptorsFieldSelector) {
	// if there is no receptor, return null
	if( $(receptorCheckboxesSelector).size()==0 && (otherReceptorsCheckboxSelector == null || !$(otherReceptorsCheckboxSelector).is(':checked')) ) {
		return null;
	} else { // create the list of
		var sep=",";
	  		var listToSend="";
	  		$(receptorCheckboxesSelector).each(function(){ listToSend = listToSend+sep+this.value; });
	  		if(otherReceptorsCheckboxSelector != null && $(otherReceptorsCheckboxSelector).is(':checked') ) {
	  			listToSend=listToSend+sep+$(otherReceptorsFieldSelector).attr("value");
	  		}
	  		return listToSend;
	}
}
