/* Usage :
var popupHandler = new KD.help.PopupHandler();
var p = {
	title "a title",
	text: "text to display",
	duration: 5000,
	direction: "left"
}
popupHandler.addPosition(p);
popupHandler.start();

TODO : ne gere pas le scroll si la tooltip est en bas de la page.
*/

KD.help = {
	PopupHandler: function (positions) {
		positions = positions || [];
		this.positions = [];
		this.tooltip = $('#_tooltipHelp');
		this.tooltipContent = $('#_tooltipHelpContent')
		this.tooltipDirection = $('#_tooltipHelpDirection')
		this.tooltipTitle = $('#_tooltipHelpTitle');
		//Init the positions with the default options
		var size = positions.length;
		for(var i=0;i<size;i++) {
			this.addPosition(positions[i]) ;
		}
	}
	
}

KD.help.PopupHandler.prototype = {
	defaultPositionOptions: {
		direction: "left",
		css: {width: "auto", height: "auto"},
		title: "",
		//See jquery UI position plugin at http://jqueryui.com/demos/position/#option-using
		my: "left center",
		at: "right center",
		offset: "0 0 0 0",
		duration: 6000,
		transitionTime: 1000, 
		collision: "flip flip"
	},
	defaultDirections: [{name: "left", my:"left center", at:"right center", offset: "-6 0 0 0"},
	                    {name: "right", my:"right center", at:"left center", offset: "6 0 0 0"},
	                    {name: "top", my:"left top", at:"left bottom", offset: "6 0 0 0"},
	                    {name: "bottom", my:"left bottom", at:"left top", offset: "-6 0 0 0"}],
	constructor: KD.help.PopupHandler,
	timeout: null,
	start: function () {
		this.stop();
		this.display(0);
	},
	stop: function () {
		if(this.timeout !=null) {
			window.clearTimeout(this.timeout);
			this.timeout = null ;
		}
	},
	display: function(i) {
		var position = this.positions[i];
		this.tooltip.fadeIn(400);
		//Change the tooltip arrow direction
		this.tooltipDirection.removeClass();
		this.tooltipDirection.addClass(position.direction);
		
		this.tooltipContent.html(position.text);
		this.tooltipTitle.html(position.title);
		for(css in position.css) {
			this.tooltip.css(css, position.css[css]);
		}
		this.tooltip.position(position);
		var that = this ;
		this.timeout = window.setTimeout(function () {that.hide(i)}, position.duration)
	},
	hide: function (i) {
		this.tooltip.fadeOut("slow");
		if(i+1<this.positions.length) {
			var that=this;
			var t = this.positions[i].transitionTime ;
			this.timeout = window.setTimeout(function () {that.display(i+1)}, t)
		}
	},
	addPosition: function (position) {
		var i = this.positions.length;
		for(var j=0;j<this.defaultDirections.length;j++) {
			//we try to give a smart position to the tooltip if nothing is defined.
			if(position.direction == this.defaultDirections[j]["name"]) {
				var that = this;
				$.each(["my", "at", "offset"], function (k, v) {
					if(typeof(position[v]) == "undefined") {
						position[v] = that.defaultDirections[j][v] ;
					}
				}) ;
				break;
			}
		}
		//Copy the default object.
		this.positions[i] = jQuery.extend(true, {}, this.defaultPositionOptions);;
		KD.utils.initOptions(position, this.positions[i]);
	}
}
