KD.login = {
	popup : null,
	init : function(registerPopup, errorMessage, popupLoginUrl) {
		var that = this;
		if (registerPopup) {
			this.popup = new Popup("_popupLogin", {
				initBeforeDisplay : function(firstDisplay) {
					if(firstDisplay) {
						$.ajax({
							url : popupLoginUrl,
							async : false,
							dataType : "html",
							success : function(data) {
								$("body").append(data);
								KD.utils.submitOnEnter('#_loginForm');
								KD.utils.initTitle("#_loginForm");
							}
						});
					}
				},
				afterDisplay: function () {
					$("#_username").focus();
					$("#_loginMessage").html("");
					$("#_loginMessage").hide();
				},
				displaySelectors : "._popupLoginAction",
				hideSelectors : [ "._buttonClose", "#_popupLogin ._popupPasswordAction" ]
			});
			this.popup.redirectInput = $("#_redirectUrl");

			this.popup.setMessage = function(loginMessage) {
				if (loginMessage != null || loginMessage == undefined) {
					$("#_loginMessage").html(loginMessage);
					$("#_loginMessage").show();
				}
			}
		}
		$("#_loginForm").live('submit', function () {
			if (!validateUsername() || !validatePassword()) {
				if (registerPopup) {
					that.popup.showError(errorMessage);
				}
				return false;
			}
		});
		
		var usernameInput = "#_username";
		var passwordInput = "#_password";

		var validateUsername = function() {
			return validate(isValidEmail, $(usernameInput), $(usernameInput).parent());
		}
		var validatePassword = function() {
			if (isValidLength($(passwordInput).val(), 6)) {
				return removeError($(passwordInput).parent());
			} else {
				return addError($(passwordInput), $(passwordInput).parent());
			}
		}
		$(usernameInput).live("change", validateUsername);
		$(passwordInput).live("change", validatePassword);
	}
}