/*
 * Call me if you need to add a notification with the given message, not the
 * code !
 */
KD.notification = {
	timer: 4000,
	span: null,
	notificationDiv: null,
	timeout: null,
	init: function() {
		if(this.span == null || this.notificationDiv == null) {
			this.notificationDiv = $("#notification");
			this.span = $("#notification span");
			var that = this ;
			$("#notification ._notification_close").click(function() {
				that.clear();
			});
		}
	},
	display: function (msg, hide) {
		this.init();
		if(typeof hide == "undefined") {
			hide = true ;
		}
		this.setMsg(msg);
		this.show(hide);
	},
	setMsg: function (msg) {
		this.span.html(msg);
	},
	show: function (autoHide) {
		this.init();

		// request data for centering
		var windowWidth = document.documentElement.clientWidth;
		var windowHeight = document.documentElement.clientHeight;
		var popupHeight = this.notificationDiv.height();
		var popupWidth = this.notificationDiv.width();
		// centering
		this.notificationDiv.css({
			"top" : windowHeight / 2 - popupHeight / 2,
			"zoom" : 1
		});
		if (jQuery.browser.msie) {
			this.notificationDiv.show();
		} else {
			this.notificationDiv.fadeIn("slow") ;
		}
		if(autoHide) {
			var that = this ;
			this.timeout = setTimeout(function () {
				that.hide();
			}, this.timer);
		}
	},
	hide: function () {
		if (jQuery.browser.msie) {
			this.clear();
		} else {
			var that = this ;
			this.notificationDiv.fadeOut("slow", function() {
				that.clear();
			});
		}
	}, 
	clear: function() {
		this.notificationDiv.hide();
		this.notificationDiv.children("span").html("");
		clearTimeout(this.timeout);
	}
};