function initPassword(errorMessage, errorsMap, popupPasswordUrl) {

	var passwordSuccessPopup = new Popup("_popupPasswordSuccess", {
		displaySelectors : "._popupPasswordSuccessAction"
	});
	var passwordPopup = new Popup("_popupPassword", {
		displaySelectors : "._popupPasswordAction",
		initBeforeDisplay : function(firstDisplay) {
			if (firstDisplay) {
				$.ajax({
					url : popupPasswordUrl,
					async : false,
					dataType : "html",
					success : function(data) {
						$("body").append(data);
						KD.utils.initTitle("#_popupPassword");
					}
				});
			}

			initValidation();

			var options = {
				beforeSubmit : showRequest, // pre-submit callback
				success : showResponse,
				dataType : 'text json'
			};

			// bind form using 'ajaxForm'
			$("form[name='passwordForm']").ajaxForm(options);
		}
	});

	passwordPopup.errorMessage = errorMessage;
	passwordPopup.errorsMap = errorsMap;

	passwordPopup.emailInput = "form[name='passwordForm'] input[name='email']";
	passwordPopup.captchaConfirmInput = "form[name='passwordForm'] input[name='captchaConfirm']";

	// pre-submit callback
	function showRequest(formData, jqForm, options) {
		if (!isAllValid()) {
			passwordPopup.showError(passwordPopup.errorMessage);
			return false;
		}

		passwordPopup.resetError();
		return true;
	}

	// post-submit callback
	function showResponse(response) {
		if (response.errors.length != 0) {
			passwordPopup.showError(passwordPopup.errorMessage);

			$.each(response.errors, function(index, elem) {
				var $input = $("form[name='passwordForm'] input[name=" + elem.field + "]");
				$input.next().html(passwordPopup.errorsMap[elem.code]);
				addError($input, $input.parent());
			});
		} else {
			passwordPopup.hide();
			passwordSuccessPopup.display();
		}
	}

	// Private methods

	function initValidation() {
		$(passwordPopup.emailInput).live("change", validateEmail);
		$(passwordPopup.captchaConfirmInput).live("change", validateCaptchaConfirm);
	}

	function validateEmail() {
		return validate(isValidEmail, $(passwordPopup.emailInput), $(passwordPopup.emailInput).parent());
	}
	function validateCaptchaConfirm() {
		return validate(isNotEmpty, $(passwordPopup.captchaConfirmInput), $(passwordPopup.captchaConfirmInput).parent());
	}

	function isAllValid() {
		var test = validateEmail();
		test = validateCaptchaConfirm() && test;
		return test;
	}
}