function initPreRegistration(agreementMessage, agreementTitle) {
	passwordLength = 6;

	firstnameInput = $("form[name='preRegistrationForm'] input[name='firstname']");
	firstnameParent = firstnameInput.parent();

	lastnameInput = $("form[name='preRegistrationForm'] input[name='lastname']");
	lastnameParent = lastnameInput.parent();

	emailInput = $("form[name='preRegistrationForm'] input[name='email']");
	emailParent = emailInput.parent();

	passwordInput = $("form[name='preRegistrationForm'] input[name='password']");
	passwordParent = passwordInput.parent();

	passwordAgainInput = $("form[name='preRegistrationForm'] input[name='passwordAgain']");
	passwordAgainParent = passwordAgainInput.parent();

	captchaConfirmInput = $("form[name='preRegistrationForm'] input[name='captchaConfirm']");
	captchaConfirmParent = captchaConfirmInput.parent();

	agreementInput = $("form[name='preRegistrationForm'] input[type='checkbox'][name='cgu']");

	initValidation();

	// Private methods

	function initValidation() {
		firstnameInput.change(function () {validateFirstname();});
		lastnameInput.change(function () {validateLastname();});
		emailInput.change(function () {validateEmail();});
		passwordInput.change(function () {validatePassword();});
		passwordAgainInput.change(function () {validatePasswordAgain();});
		captchaConfirmInput.change(function () {validateCaptchaConfirm();});
		firstnameInput.focus();

		$("form[name='preRegistrationForm']").submit(function() {
			if (validateAgreement()) {
				return isAllValid();
			}
			return false;
		});
	}

	function validateFirstname() {
		return validate(isNotEmpty, firstnameInput, firstnameParent);
	}

	function validateLastname() {
		return validate(isNotEmpty, lastnameInput, lastnameParent);
	}

	function validateEmail(e) {
		return validate(isValidEmail, emailInput, emailParent);
	}

	function validatePassword() {
		if (isValidLength(passwordInput.val(), passwordLength)) {
			return removeError(passwordParent);
		} else {
			return addError(passwordInput, passwordParent);
		}
	}

	function validatePasswordAgain() {
		if (isEquals(passwordAgainInput.val(), passwordInput.val())) {
			return removeError(passwordAgainParent);
		} else {
			return addError(passwordAgainInput, passwordAgainParent);
		}
	}

	function validateCaptchaConfirm() {
		return validate(isNotEmpty, captchaConfirmInput, captchaConfirmParent);
	}

	function validateAgreement() {
		if (!agreementInput.is(":checked")) {
			jAlert(agreementMessage, agreementTitle);
			return false;
		}
		return true;
	}

	function isAllValid() {
		var test = validateFirstname();
		test = validateLastname() && test;
		test = validateEmail() && test;
		test = validatePassword() && test;
		test = validatePasswordAgain() && test;
		test = validateCaptchaConfirm() && test;
		return test;
	}

}