KD.search = {
	filterHideMessage : null,
	filterShowMessage : null,
	flowExecutionUrl : null,
	saveSearchUrl : null,
	popupHandler: null,
	messages: null,
	init : function(admin, flowExecutionUrl, saveSearchUrl, filterHideMessage, filterShowMessage, messages) {
		this.messages = messages;
		this.filterHideMessage = filterHideMessage;
		this.filterShowMessage = filterShowMessage;
		this.flowExecutionUrl = flowExecutionUrl;
		this.saveSearchUrl = saveSearchUrl;

		$('#_reloadByName').click(this.reloadByName);
		$('#_reloadByActivity').click(this.reloadByActivity);

		$('#_reloadByNameErr').click(this.reloadByName);
		$('#_reloadByActivityErr').click(this.reloadByActivity);

		$("#_search_pagination").change(this.changePagination);
		$("#_search_sort").change(this.changeSort);
		$("#_search_in").change(this.changePerimeter);

		$("._validFilterFormSubmit").click(this.submitFilters);
		$("#_resetFilterFormSubmit").click(this.resetFilters);

		$("._filterShowAll").toggle(this.showFilters, this.hideFilters);

		if (admin) {
			$("._searchScore").click(this.toogleExplanation);
			$("#_saveSearch").click(this.saveSearch);
			if ($("#_search_in").val() != undefined && $("#_search_in").val() != "" && $("#_resultNumber").text() != "0") {
				activateButtons($("#_saveSearch"));
			}
		}
		var helpButton = $('#_helpButton') ;
		if(helpButton.length>0) {
			this.popupHandler = new KD.help.PopupHandler();
			if($("#_validFilterFormSubmitTop").length>0) {
				this.popupHandler.addPosition({text: this.messages[0].txt, title: this.messages[0].title, of: "#_validFilterFormSubmitTop", at:"right bottom", css:{width:300}, offset: "3 12 0 0"});
				this.popupHandler.addPosition({text: this.messages[1].txt, title: this.messages[1].title, of: "#_popupSaveTargetAction", direction: "top", offset: "0 4 0 0"});
				var firstViadeoSearchIcon = $('.linkedinSearchIcon').filter(":first");
				if(firstViadeoSearchIcon.length>0) {
					this.popupHandler.addPosition({text: this.messages[2].txt, title: this.messages[2].title, css:{width:300},of: firstViadeoSearchIcon, direction: "right", offset:"-6 22 0 0"});
				}
			} else {
				this.popupHandler.addPosition({text: this.messages[0].txt, title: this.messages[0].title, of: "#_reloadByActivityErr, #_reloadByNameErr", direction: "top", offset: "20 4 0 0"});
			}
			var that =this ;
			helpButton.click(function () {
				that.popupHandler.start();
			});
		}
		$('_validFilterFormSubmit');
	},
	saveSearch : function() {
		if (!$("#_saveSearch").hasClass("_desactivated")) {
			$('#_filterForm').prop("action", KD.search.saveSearchUrl);
			$('#_filterForm').prop("method", "post");
			$('#_filterForm').ajaxSubmit({
				success : function(json, status) {
					KD.notification.display(json.notification, true);
				}
			});

			$('#_filterForm').prop("action", "");
			$('#_filterForm').prop("method", "get");
		}
	},

	toogleExplanation : function() {
		var id = $(this).attr("id");
		$("#_explanation_" + id).toggle();
	},

	reloadByName : function() {
		$('#_searchType1').prop('checked', true);
		$('#_searchForm').submit();
	},

	reloadByActivity : function() {
		$('#_searchType0').prop('checked', true);
		$('#_searchForm').submit();
	},
	changePerimeter : function() {
		$("#_filterFormTarget").val($(this).val());
		$("#_filterFormSearchBy").val("SITE");
		var $form = $("#_filterForm");
		$form.attr("action", KD.search.flowExecutionUrl + "&_eventId=search");
		$form.submit();
	},
	changePagination : function() {
		$("#_filterFormPagination").val($(this).val());
		var $form = $("#_filterForm");
		$form.attr("action", KD.search.flowExecutionUrl + "&_eventId=otherPagination");
		$form.submit();
	},

	changeSort : function() {
		$("#_filterFormOrderBy").val($(this).val());
		var $form = $("#_filterForm");
		$form.attr("action", KD.search.flowExecutionUrl + "&_eventId=order");
		$form.submit();
	},

	submitFilters : function() {
		$("#_filterForm").submit();
	},

	resetFilters : function() {
		$("#_searchForm").submit();
	},

	showFilters : function() {
		$(this).addClass("mixdatav2_upCircleArrow");
		$(this).removeClass("mixdatav2_downCircleArrow");
		$(this).children("input").val(KD.search.filterHideMessage);
		$(this).next().toggle(300);
	},

	hideFilters : function() {
		$(this).addClass("mixdatav2_downCircleArrow");
		$(this).removeClass("mixdatav2_upCircleArrow");
		$(this).children("input").val(KD.search.filterShowMessage);
		$(this).next().hide();
	}

}
