function initSearchSelection(relativeUrl, flowExecutionUrl, maxCompaniesInSelection, tooManyTitle, tooManyMessage) {

	// Div selection for faster acces to mixdatav2_selectionContentColumnLine
	var divSelection = $(".mixdatav2_selectionContentArea");
	divSelection.click(removeCompanyFromSelectionList);

	// ============== Toggle selectionContentArea
	divSelection.hide();

	$("#_showSelection").toggle(function() {
		divSelection.slideToggle(300);
	}, function() {
		divSelection.slideToggle(300);
	});

	$("#_buttonEraseSelection").click(removeAllFromSelectionList);

	var checkboxesJq = $("._companyRemoverAndAdder");
	var checkboxes = [];
	checkboxesJq.each(function(i) {
		checkboxes[i] = $(this);
		checkboxes[i].click(addOrRemoveCompanyFromCompaniesList);
	});
	var selectionCheckboxes = [];
	delete checkboxesJq;

	$("#_all").click(addOrRemoveAllFromCompaniesList);

	var spanSelectionNumber = $("#_selectionNumber");

	updateResumeAndTheAllCheckBox();

	// =================== selection when clicking on the row
	$(".result").click(function(e) {
		if (!$(e.target).is("a")) {
			var checkbox = $(this).find("input[type='checkbox']");
			if (checkbox.prop("checked")) {
				checkbox.prop("checked", false);
				checkbox.click();
				checkbox.prop("checked", false);
			} else {
				if (tooManySelected()) {
					alertTooManySelected();
					return false;
				} else {
					checkbox.prop("checked", true);
					checkbox.click();
					checkbox.prop("checked", true);
				}
			}
		}
	});

	// *****
	// Private first level
	function updateResumeAndTheAllCheckBox() {
		var nbCompaniesSelected = divSelection.children(".mixdatav2_selectionContentColumnLine").size();
		$("#_all").prop("checked", isAllCheckBoxesChecked());
		createStringOfList(divSelection.find("input._selected_id:checked"), $("._popupSaveTargetAction"), "name", true);
	}

	/**
	 * 
	 * @returns {Boolean} true if all checkboxes are checked
	 */
	function isAllCheckBoxesChecked() {
		var size = checkboxes.length;
		for ( var i = 0; i < size; i++) {
			if (!checkboxes[i].prop("checked")) {
				return false;
			}
		}
		return true;
	}

	function addOrRemoveCompanyFromCompaniesList(event) {
		$target = $(event.target);
		var companyId = getCompanyIdFromResultCheckBox($target);
		if ($target.prop("checked")) {
			if (tooManySelected()) {
				alertTooManySelected();
				return false;
			} else {
				var companyName = getCompanyNameFromResultCheckBox(companyId);
				var companyIndex = getCompanyIndexFromResultCheckBox($target);
				addCompanyInSelectionListAndCheckInResult(companyName, companyId, companyIndex);
				updateResumeAndTheAllCheckBox();
				sendAddCompany(companyIndex);
			}
		} else {
			removeCompanyFromSelectionAndUncheckInResult(companyId);
			updateResumeAndTheAllCheckBox();
			sendRemoveCompanyById(companyId);

		}
		event.stopPropagation();
		return true;
	}

	function removeCompanyFromSelectionList(event) {
		$target = $(event.target);
		if ($target.hasClass("_selected_id")) {
			var companyId = $target.val();
			removeCompanyFromSelectionAndUncheckInResult(companyId);
			updateResumeAndTheAllCheckBox();
			sendRemoveCompanyById(companyId);
			event.stopPropagation();
		}
		return true;
	}

	function addOrRemoveAllFromCompaniesList(event) {
		$target = $(event.target);
		if (!$target.prop("checked")) {
			$.each(checkboxes, function(i, checkbox) {
				if (checkbox.prop("checked")) {
					var companyId = getCompanyIdFromResultCheckBox(checkbox);
					removeCompanyFromSelectionAndUncheckInResult(companyId);
					checkbox.prop("checked", false);
				}
			});
			updateResumeAndTheAllCheckBox();
			sendRemoveUsFromList();
		} else {
			var nbUncheked = 0;
			$.each(checkboxes, function(i, checkbox) {
				if (!checkbox.prop("checked")) {
					nbUncheked++;
				}
			});
			if (tooManySelectedAfter(nbUncheked)) {
				alertTooManySelected();
				event.stopPropagation();
				return false;
			} else {
				$.each(checkboxes, function(i, checkbox) {
					if (!checkbox.prop("checked")) {
						checkbox.prop("checked", true);
						var companyId = getCompanyIdFromResultCheckBox(checkbox);
						var companyName = getCompanyNameFromResultCheckBox(companyId);
						var companyIndex = getCompanyIndexFromResultCheckBox(checkbox);
						addCompanyInSelectionListAndCheckInResult(companyName, companyId, companyIndex);
					}
				});
				updateResumeAndTheAllCheckBox();
				sendAddUsToList();
			}
		}
		event.stopPropagation();

	}
	// ********************
	// Private others levels

	function getCompanyNameFromResultCheckBox(companyId) {
		return $("a[name='" + companyId + "']").html();
	}

	function getCompanyIndexFromResultCheckBox($checkBox) {
		return $checkBox.val();
	}
	function getCompanyIdFromResultCheckBox($checkBox) {
		return $checkBox.next().val();
	}

	function removeAllFromSelectionList(event) {
		updateSelectionSize();
		removeAllSelectionsInSelectionList();
		setAllCompaniesUncheckedInResult();
		updateResumeAndTheAllCheckBox();
		sendResetSelection();
		event.stopPropagation();
		return false;

		function removeAllSelectionsInSelectionList() {
			$(".mixdatav2_selectionContentColumnLine").remove();
		}
		function setAllCompaniesUncheckedInResult() {
			$("input[type=checkbox][name=_selection]:checked").prop("checked", false);
		}
		function updateSelectionSize() {
			spanSelectionNumber.text(0);
		}
	}

	function addCompanyInSelectionListAndCheckInResult(companyName, companyId, companyIndex) {
		if (!isCompanyAlreadyAddedToSelection(companyId)) {
			$("#_selectionCompanies").append(
					"<div class='mixdatav2_selectionContentColumnLine'>" + "<input type='checkbox' checked=true class='_selected_id' value='"
							+ companyId + "'/>" + "<label for='" + companyId + "'>" + companyName + "</label>" + "</div>");
			changeTotalSelection(1);
		}
	}

	function removeCompanyFromSelectionAndUncheckInResult(companyId) {
		var inSelection = false;
		divSelection.find("input._selected_id").each(function() {
			if ($(this).val() == companyId) {
				$(this).parent().remove();
				inSelection = true;
				return false;
			}
		});
		$.each(checkboxes, function(i, checkbox) {
			if (checkbox.next().val() == companyId) {
				checkbox.prop("checked", false);
				return false;
			}
		});
		if (inSelection) {
			changeTotalSelection(-1);
		}
	}

	function tooManySelected() {
		var selectedNumber = parseInt(spanSelectionNumber.text());
		return selectedNumber >= maxCompaniesInSelection;
	}

	function tooManySelectedAfter(number) {
		var selectedNumber = parseInt(spanSelectionNumber.text());
		var totalNumber = number + selectedNumber;
		return totalNumber > maxCompaniesInSelection;
	}

	function alertTooManySelected() {
		jAlert(tooManyMessage, tooManyTitle);
	}

	function sendAddCompany(companyIndex) {
		sendToServer(flowExecutionUrl + "&_eventId=addMeToList&index=" + companyIndex);
	}
	function sendRemoveUsFromList() {
		sendToServer(flowExecutionUrl + "&_eventId=removeUsFromList");
	}
	function sendAddUsToList() {
		sendToServer(flowExecutionUrl + "&_eventId=addUsToList");
	}
	function sendRemoveCompanyById(companyId) {
		sendToServer(flowExecutionUrl + "&_eventId=removeMeFromList&id=" + companyId);
	}
	function sendResetSelection() {
		sendToServer(flowExecutionUrl + "&_eventId=resetSelection");
	}
	function sendToServer(url) {
		$.ajax({
			url : url
		});
	}

	function isCompanyAlreadyAddedToSelection(companyId) {
		return $("input._selected_id[value='" + companyId + "']").length == 1;
	}

	function changeTotalSelection(addNumber) {
		var total = parseInt(spanSelectionNumber.text());
		total += addNumber;
		spanSelectionNumber.text(total);
	}
}
