/*
 * This function binds a master checkBox to a list of checkBoxes.

 * 
 * If the list is empty the master checkBox is disabled, else
 * its status -checked or not- reflects whether all checkBoxes are checked or not.
 * 
 * If the user clicks on the master checkBox the status of the list is updated and
 * if the user clicks on any ckeckBox the status of the master checkBox is updated.
 * 
 * selectAllCheckboxId : id of the master checkBox
 * checkboxesName : name of the checkBoxes (they should all have the same name)
*/
function selectAllCheckbox(selectAllCheckboxId, checkboxesName){
	selectAllCheckboxWithDoAfter(selectAllCheckboxId, checkboxesName, function() {});
}

function selectAllCheckboxWithDoAfter(selectAllCheckboxId, checkboxesName, doAfter){
	
	// jquery selectors which are used everywhere
	var checkboxesSelector = "input[name="+checkboxesName+"]";
	var buttonSelector = "#"+selectAllCheckboxId;
	selectAllCheckbox.checkedBeforeAll = $(checkboxesSelector+":checked");
	
	// returns what should be the status of the master checkBox
	function isAllSelected() {
		var boxes = $(checkboxesSelector);
		var checkedBoxes = $(checkboxesSelector+":checked");
		if(boxes.length==0) {
			return 0;
		} else return (checkedBoxes.length == boxes.length);
	}
	
	// if the list is empty
	if($(checkboxesSelector).length==0) {
		// the master checkBox is disabled
		$(buttonSelector).each(function(){
     		$(this).attr("disabled","disabled");
     	});
	} else {
		var allSelected = isAllSelected();
		$(buttonSelector).each(function(){
			this.checked=allSelected;
		});
		
		// else the master checkBox status change the status
		// of the other checkBoxes
		$(buttonSelector).change(function(){
			selectAllCheckbox.checkedBeforeAll = $(checkboxesSelector+":checked");
			var checked_status = this.checked; 
			$(checkboxesSelector).each(function(){ 
				this.checked = checked_status; 
			}); 
			doAfter();
		});
     
		// and if any checkBox is changed, it should
		// be verified if they are all checked
		$(checkboxesSelector).change(function(){
			selectAllCheckbox.checkedBeforeAll = $(checkboxesSelector+":checked");
			var allSelected = isAllSelected();
			$(buttonSelector).each(function(){
				this.checked=allSelected;
			});
			doAfter();
		});
	} 
	
}