KD.target.save = {

	saveTargetPopup : null,

	/**
	 * When the user isn't logged, should only call the login popup. TODO :
	 * instead, call a global #displayLoginPopup which will display the login
	 * popup with an ajax call.
	 */
	initNotLogged : function(loginMessage) {
		this.saveTargetPopup = new Popup("_popupSaveTarget", {
			needLoggedUser : true,
			displaySelectors : "._popupSaveTargetAction",
			loginMessage : loginMessage
		});
	},
	/**
	 * Init the target TODO this is quite messy. Adding properties to the Popup
	 * object may not be the best solution. Properties should be directly stored
	 * in the KD.target.save object or similar.
	 */
	init : function(errorMessage, noSelectionMessage, noSelectionMessageTitle, targetNameMinSize, targetNameMaxSize, targetsMineUrl) {
		var that = this;
		that.saveTargetPopup = new Popup("_popupSaveTarget", {
			needLoggedUser : true,
			displaySelectors : "._popupSaveTargetAction",
			initBeforeDisplay : beforeDisplay
		});

		that.saveTargetPopup.errorMessage = errorMessage;
		that.saveTargetPopup.noSelectionMessage = noSelectionMessage;
		that.saveTargetPopup.noSelectionMessageTitle = noSelectionMessageTitle;
		that.saveTargetPopup.targetNameMinSize = targetNameMinSize;
		that.saveTargetPopup.targetNameMaxSize = targetNameMaxSize;
		that.saveTargetPopup.targetsMineUrl = targetsMineUrl;

		that.saveTargetPopup.form = $("form[name='saveTargetForm']");
		that.saveTargetPopup.method = $("form[name='saveTargetForm'] input[name='_method']");
		that.saveTargetPopup.saveRadioInput = $("form[name='saveTargetForm'] input[type='radio'][name='save'][value='true']");
		that.saveTargetPopup.updateRadioInput = $("form[name='saveTargetForm'] input[type='radio'][name='save'][value='false']");
		that.saveTargetPopup.targetIdInput = $("form[name='saveTargetForm'] select[name='target\\.id']");
		that.saveTargetPopup.targetIdParent = that.saveTargetPopup.targetIdInput.parent();
		that.saveTargetPopup.targetNameInput = $("form[name='saveTargetForm'] input[name='target\\.name']");
		that.saveTargetPopup.targetNameParent = that.saveTargetPopup.targetNameInput.parent();
		that.saveTargetPopup.targetDescriptionInput = $("form[name='saveTargetForm'] textarea[name='target\\.description']");
		that.saveTargetPopup.tagsInput = $("form[name='saveTargetForm'] textarea[name='tags']");
		that.saveTargetPopup.targetCompaniesInput = $("form[name='saveTargetForm'] input[name='target\\.companies']");
		that.saveTargetPopup.targetsById = new Array();
		that.saveTargetPopup.targets = new Array();
		that.saveTargetPopup.shouldDisplay = shouldDisplay;
		initValidation();

		function beforeDisplay(firstDisplay) {
			var nameAttr = $("._popupSaveTargetAction").attr("name");
			that.saveTargetPopup.form.find(".mixdatav2_genericInputAlertMsg").css("display", "none");
			that.saveTargetPopup.nbCompanies = nameAttr.split(",").length;
			that.saveTargetPopup.targetCompaniesInput.val(nameAttr);
			that.saveTargetPopup.targetNameInput.val("");
			that.saveTargetPopup.targetDescriptionInput.val("");
			that.saveTargetPopup.tagsInput.val("");
			that.saveTargetPopup.resetError();
			$.getJSON(targetsMineUrl, loadData);
		}

		function shouldDisplay() {
			// retrieves the target id stored in the name attribute of the
			// current
			// element (a, input, etc.).

			var nameAttr = $("._popupSaveTargetAction").attr("name");
			if (hasNoText(nameAttr)) {
				jAlert(that.saveTargetPopup.noSelectionMessage, that.saveTargetPopup.noSelectionMessageTitle);
				return false;
			}
			return true;
		}

		function loadData(data) {
			that.saveTargetPopup.maxCompanyNumber = data.overview.maxCompanyNumber;
			that.saveTargetPopup.maxTargetNumber = data.overview.maxTargetNumber;
			var targets = data.overview.targetInfos;

			if (targets.length != 0) {
				that.saveTargetPopup.targetIdInput.html("");
				$.each(targets, function(indexInArray, valueOfElement) {
					that.saveTargetPopup.targetIdInput.append('<option value="' + valueOfElement.target.id + '">' + valueOfElement.target.name + ' ('
							+ valueOfElement.nbCompanies + ')</option>');
					that.saveTargetPopup.targetsById[valueOfElement.target.id] = valueOfElement;
				});

				that.saveTargetPopup.targets = targets;

				that.saveTargetPopup.targetIdInput.children("option").change(function() {
					var targetInfo = that.saveTargetPopup.targetsById[$(this).val()];
					if (targetInfo) {
						that.saveTargetPopup.targetDescriptionInput.val(targetInfo.target.description);
					}
				});

				that.saveTargetPopup.targetIdParent.show();
				if (that.saveTargetPopup.maxTargetNumber != -1 && that.saveTargetPopup.maxTargetNumber <= data.overview.numberOfPersonalTargets) {
					$("._target_name_input").hide();
					$("._target_id_input").show();
					that.saveTargetPopup.updateRadioInput.hide();
					that.saveTargetPopup.updateRadioInput.click();
					limitedByTargetNumber();
				} else {
					that.saveTargetPopup.saveRadioInput.show();
					that.saveTargetPopup.saveRadioInput.click();
				}
			}
			if (that.saveTargetPopup.maxTargetNumber == -1) {
				$("._target_number").text(data.overview.numberOfPersonalTargets);
			} else {
				$("._target_number").text(data.overview.numberOfPersonalTargets + "/" + that.saveTargetPopup.maxTargetNumber);
			}

			$("._target_id_input").find("div.mixdatav2_genericInputAlertMsgbloc span strong").text(that.saveTargetPopup.maxCompanyNumber);
		}

		function initValidation() {
			var options = {
				beforeSubmit : validRequest,
				success : successCallback,
				dataType : 'text json'
			};

			that.saveTargetPopup.form.ajaxForm(options);

			that.saveTargetPopup.updateRadioInput.click(function() {
				that.saveTargetPopup.targetIdInput.removeAttr("disabled");
				that.saveTargetPopup.targetNameInput.attr("disabled", "disabled");
				that.saveTargetPopup.targetDescriptionInput.attr("disabled", "disabled");
				that.saveTargetPopup.method.removeAttr("disabled");
				removeError(that.saveTargetPopup.targetNameParent);
				that.saveTargetPopup.targetDescriptionInput
						.val(that.saveTargetPopup.targetsById[that.saveTargetPopup.targetIdInput.val()].target.description);
				verifySize(that.saveTargetPopup.targetIdInput.val());
			});
			that.saveTargetPopup.saveRadioInput.click(function() {
				that.saveTargetPopup.targetNameInput.removeAttr("disabled");
				that.saveTargetPopup.targetDescriptionInput.removeAttr("disabled");
				that.saveTargetPopup.targetIdInput.attr("disabled", "disabled");
				that.saveTargetPopup.method.attr("disabled", "disabled");
				removeError(that.saveTargetPopup.targetIdParent);
				that.saveTargetPopup.targetDescriptionInput.val("");
			});

			that.saveTargetPopup.targetIdInput.change(function() {
				if (verifySize($(this).val())) {
					that.saveTargetPopup.targetDescriptionInput.val(that.saveTargetPopup.targetsById[$(this).val()].target.description);
				}
			});
			that.saveTargetPopup.targetNameInput.change(function() {
				verifyTargetName();
			});

			$("._actionSaveTarget").click(function() {
				that.saveTargetPopup.form.submit();
			});
		}

		function validRequest() {
			if (!valideAll()) {
				that.saveTargetPopup.showError(that.saveTargetPopup.errorMessage);
				return false;
			}
			that.saveTargetPopup.resetError();
			return true;
		}

		function successCallback(data) {
			if (data.errors != undefined) {
				$.each(data.errors, function(index, elem) {
					if (elem.field != undefined) {
						var $input = $("form[name='saveTargetForm'] *[name='" + elem.field + "']");
						$errorSpan = $input.parent().find("span.mixdatav2_genericInputAlertMsg");
						$errorSpan.html(elem.defaultMessage);
						$errorSpan.show();
						addError($input, $input.parent());
					}
				});
				that.saveTargetPopup.showError(that.saveTargetPopup.errorMessage);
			} else if (data.accessLimitation) {
				limitedByTargetNumber();
			} else {
				that.saveTargetPopup.hide();
				KD.notification.display(data.notification, true);
			}
		}

		function valideAll() {
			return (!that.saveTargetPopup.saveRadioInput.is(":checked") && verifySize(that.saveTargetPopup.targetIdInput.val()))
					|| (that.saveTargetPopup.saveRadioInput.is(":checked") && verifyTargetName());
		}

		function verifySize(targetId) {
			var targetInfo = that.saveTargetPopup.targetsById[targetId];
			if ((targetInfo != undefined && (targetInfo.nbCompanies + that.saveTargetPopup.nbCompanies) > that.saveTargetPopup.maxCompanyNumber)
					|| (that.saveTargetPopup.nbCompanies > that.saveTargetPopup.maxCompanyNumber)) {
				that.saveTargetPopup.showError(that.saveTargetPopup.errorMessage);
				return addError(that.saveTargetPopup.targetIdInput, that.saveTargetPopup.targetIdParent);
			} else {
				that.saveTargetPopup.resetError();
				return removeError(that.saveTargetPopup.targetIdParent);
			}
		}

		function verifyTargetName() {
			if (!isLengthBetween(that.saveTargetPopup.targetNameInput.val(), that.saveTargetPopup.targetNameMinSize,
					that.saveTargetPopup.targetNameMaxSize)) {
				return addError(that.saveTargetPopup.targetNameInput, that.saveTargetPopup.targetNameParent);
			}
			return removeError(that.saveTargetPopup.targetNameParent);
		}

		function limitedByTargetNumber() {
			$("._target_number").text(that.saveTargetPopup.maxTargetNumber + "/" + that.saveTargetPopup.maxTargetNumber);
			$("._target_number").addClass("mixdatav2_genericPopUpUnderTitleCountDown");
			$("._upgrade").show();
		}
	}
}