function initTracker(tracker_code) {

	_gaq.push([ '_setAccount', tracker_code ]);
	_gaq.push([ '_setDomainName', '.mixdata.com' ]);
	_gaq.push([ '_trackPageview' ]);

	// ////////////////////////////////////////////////////////////////
	// SEARCH

	// Help
	$('#_helpButton').click(function() {
		var klass = $(this).children(":first").attr("class");
		_gaq.push([ '_trackEvent', 'help', 'display' ], klass);
	});

	// Search
	$("form[name='search'] input[type='submit']").click(
			function() {
				// track number of search with the type of search (ACTIVITY or
				// COMPANY)
				// and the query
				_gaq.push([ '_trackEvent', 'search',
						$("form[name='search'] *[name='searchBy']").val(),
						$("form[name='search'] input[name='query']").val() ]);
			});

	// Search pagination
	$("._searchPagination").click(
			function() {
				var link = $(this).attr("href");
				_gaq.push([ '_trackEvent', 'search', 'pagination',
						link.charAt(link.length - 1) ]);
			});

	// relaunch search
	$("#_reloadByNameErr").click(function() {
		_gaq.push([ '_trackEvent', 'search', 'reload', 'nameButton' ]);
	});
	$("#_reloadByName").click(function() {
		_gaq.push([ '_trackEvent', 'search', 'reload', 'nameLink' ]);
	});
	$("#_reloadByActivityErr").click(function() {
		_gaq.push([ '_trackEvent', 'search', 'reload', 'activityButton' ]);
	});
	$("#_reloadByActivity").click(function() {
		_gaq.push([ '_trackEvent', 'search', 'reload', 'activityLink' ]);
	});

	// Filter Search by type
	$("#_filterForm")
			.submit(
					function() {
						_gaq.push([ '_trackEvent', 'filter', 'filter' ]);

						var target = $("#_filterFormTarget");
						if (target.val() != "") {
							_gaq.push([ '_trackEvent', 'filter', 'target',
									target.val() ]);
						}

						var searchBy = $("#_filterFormSearchBy");
						_gaq.push([ '_trackEvent', 'filter', 'searchBy',
								searchBy ]);

						var naf = $(
								"#_filterForm input[type='checkbox'][name='naf']:checked")
								.size();
						_gaq.push([ '_trackEvent', 'filter', 'naf', naf ]);

						var region = $(
								"#_filterForm input[type='checkbox'][name='region']:checked")
								.size();
						_gaq
								.push([ '_trackEvent', 'filter', 'region',
										region ]);

						var turnover = $(
								"#_filterForm input[type='checkbox'][name='turnover']:checked")
								.size();
						_gaq.push([ '_trackEvent', 'filter', 'turnover',
								turnover ]);

						var manpower = $(
								"#_filterForm input[type='checkbox'][name='manpower']:checked")
								.size();
						_gaq.push([ '_trackEvent', 'filter', 'manpower',
								manpower ]);

						return true;
					});

	// Reset Filter Search
	$("#_resetFilterFormSubmit").click(function() {
		_gaq.push([ '_trackEvent', 'filter', 'reset' ]);
	});

	// ////////////////////////////////////////////////////////////////
	// PAGINATED SELECTION

	$("#_showSelection").click(function() {
		_gaq.push([ '_trackEvent', 'search', 'selection', 'show' ]);
	});

	$("#_buttonEraseSelection").click(function() {
		_gaq.push([ '_trackEvent', 'search', 'selection', 'delete' ]);
	});

	// ////////////////////////////////////////////////////////////////
	// TARGET

	//Search in a target
	$("#_searchInTargetSubmitForm").submit(function () {
		_gaq.push([ '_trackEvent', 'target', 'search-in-target']);
		return true ;
	});
	
	// Save a search as a new target
	$("#_saveSearch").click(function() {
		if (!$(this).hasClass("_desactivated")) {
			_gaq.push([ '_trackEvent', 'target', 'save-search' ]);
		}
	});

	// Import target
	$("#_importTargetForm").submit(function() {
		_gaq.push([ '_trackEvent', 'target', 'import-from-siren' ]);
		return true;
	});
	// Search target

	// Target creation list with the number of companies in the original list
	$("._actionSaveTarget._searchPage")
			.click(
					function() {
						var companies = $(
								"form[name='saveTargetForm'] input[type='hidden'][name='target.companies']")
								.val().split(",").length;
						if ($("#saveTarget").is(":checked")) {
							_gaq.push([ '_trackEvent', 'target',
									'create-from-search', companies ]);
						} else {
							_gaq.push([ '_trackEvent', 'target',
									'update-from-search', companies ]);
						}
					});

	// Target creation from company page
	$("._actionSaveTarget._companyPage").click(function() {
		if ($("#saveTarget").is(":checked")) {
			_gaq.push([ '_trackEvent', 'target', 'create-from-company' ]);
		} else {
			_gaq.push([ '_trackEvent', 'target', 'update-from-company' ]);
		}
	});

	// Share a target
	$("form[name='_shareTargetForm'] input[type='submit']").click(function() {
		_gaq.push([ '_trackEvent', 'target', 'share' ]);
	});

	// Delete a target
	$("form[name='deleteTargetForm']").click(function() {
		_gaq.push([ '_trackEvent', 'target', 'delete', 'target' ]);
	});

	// Delete a selection of companies from a target
	$("#_removeCompanies").click(function() {
		_gaq.push([ '_trackEvent', 'target', 'delete', 'companies' ]);
	});

	// ////////////////////////////////////////////////////////////////
	// TAG

	// Tag a list of companies
	$("._actionTag").click(function() {
		_gaq.push([ '_trackEvent', 'target', 'tags', 'add' ]);
	});

	// Delete tag on a company
	$("._company_tag_delete").click(function() {
		_gaq.push([ '_trackEvent', 'target', 'tags', 'remove' ]);
	});

	// ////////////////////////////////////////////////////////////////
	// COMPANY PROFILE

	// Click on description source link
	$("._companySourceLink").click(function() {
		_gaq.push([ '_trackEvent', 'company', 'link', 'source' ]);
	});

	// Click on company site link
	$("._companySiteLink").click(function() {
		_gaq.push([ '_trackEvent', 'company', 'link', 'site' ]);
	});

	// Contact an user of a company
	$("form[name='contactDirectlyForm'] input[type='submit']").click(
			function() {
				_gaq.push([ '_trackEvent', 'company', 'send-message' ]);
			});

	// See summary of a company
	$("#_companySummary").click(function() {
		_gaq.push([ '_trackEvent', 'company', 'summary' ]);
	});

	// See activities of a company
	$("#_companyActivity").click(function() {
		_gaq.push([ '_trackEvent', 'company', 'activities' ]);
	});

	// See contacts of a company
	$("#_companyContact").click(function() {
		_gaq.push([ '_trackEvent', 'company', 'contacts' ]);
	});

	// See offices of a company
	$("#_companyOffices").click(function() {
		_gaq.push([ '_trackEvent', 'company', 'offices' ]);
	});

	// ////////////////////////////////////////////////////////////////
	// SOCIAL NETWORK LINK

	// Click on a linked-in profile from contacts list
	$("._contactLinkedinLink").live("click", function() {
		_gaq.push([ '_trackEvent', 'rsp', 'linkedin', 'contacts' ]);
	});

	// Click on a viadeo profile from contacts list
	$("._contactViadeoLink").live("click", function() {
		_gaq.push([ '_trackEvent', 'rsp', 'viadeo', 'contacts' ]);
	});

	// Click on a linked-in profile form a vcard on a contacts list
	$("._companyPage ._vcardLinkedinLink").live("click", function() {
		_gaq.push([ '_trackEvent', 'rsp', 'linkedin', 'vcard-contact' ]);
	});

	// Click on a viadeo profile form a vcard on a contacts list
	$("._companyPage ._vcardViadeoLink").live("click", function() {
		_gaq.push([ '_trackEvent', 'rsp', 'viadeo', 'vcard-contact' ]);
	});

	// Click on a linked-in profile form a vcard on a addressbook
	$("._addressbookPage ._vcardLinkedinLink").click(function() {
		_gaq.push([ '_trackEvent', 'rsp', 'linkedin', 'vcard-addressbook' ]);
	});

	// Click on a viadeo profile form a vcard on a addressbook
	$("._addressbookPage ._vcardViadeoLink").click(function() {
		_gaq.push([ '_trackEvent', 'rsp', 'viadeo', 'vcard-addressbook' ]);
	});

	// ////////////////////////////////////////////////////////////////
	// ADDRESS BOOK

	// Export contact with format and number of contacts exported
	$("._exportContact").click(
			function() {
				var contacts = $(
						"form[name='exportContactForm'] input[name='ids']")
						.val().split(",").length;
				var format = $(
						"form[name='exportContactForm'] select[name='format']")
						.val();
				_gaq.push([ '_trackEvent', 'addressbook', format, contacts ]);
			});

	// Edit or create a kadmail contact
	$("._validate_create_edit")
			.click(
					function() {
						var id = $(
								"form[name='addContactForm'] input[name='kadmailContact\\.id']")
								.val();
						_gaq.push([
								'_trackEvent',
								'addressbook',
								(id == undefined || id == "") ? 'create'
										: 'edit' ]);
					});

	// Add contact from company profile to address book
	$("._addToAddresseBook_selectedone").live("click", function() {
		_gaq.push([ '_trackEvent', 'addressbook', 'add' ]);
	});

	// ////////////////////////////////////////////////////////////////
	// KADMAIL

	// Write a new kadmail message
	$("#writeKadmailForm input[type='submit']").click(function() {
		_gaq.push([ '_trackEvent', 'kadmail', 'write' ]);
	});

	// ////////////////////////////////////////////////////////////////
	// CART

	$("#_addToCart").click(function() {
		var nbItems = $("#_resultNumber").first().text();
		_gaq.push([ '_trackEvent', 'cart', 'add', nbItems ]);
	});

	$("#cartReset").click(function() {
		_gaq.push([ '_trackEvent', 'cart', 'reset' ]);
	});

	$("a[name='delete']").click(function() {
		_gaq.push([ '_trackEvent', 'cart', 'delete' ]);
	});

	$("._popupFileComposition").click(function() {
		_gaq.push([ '_trackEvent', 'cart', 'show_example' ]);
	});

	$("#buyMoreCredits").click(function() {
		_gaq.push([ '_trackEvent', 'cart', 'buy_credits' ]);
	});

	$("#cartValidation").click(function() {
		_gaq.push([ '_trackEvent', 'cart', 'valid' ]);
	});
}